#ifndef __X10_UTIL_SET_H
#define __X10_UTIL_SET_H

#include <x10rt.h>


#define X10_LANG_ANY_H_NODEPS
#include <x10/lang/Any.h>
#undef X10_LANG_ANY_H_NODEPS
#define X10_UTIL_COLLECTION_H_NODEPS
#include <x10/util/Collection.h>
#undef X10_UTIL_COLLECTION_H_NODEPS
namespace x10 { namespace util { 

template<class TPMGL(T)> class Set;
template <> class Set<void>;
template<class TPMGL(T)> class Set   {
    public:
    RTT_H_DECLS_INTERFACE
    
    template <class I> struct itable {
        itable(x10_boolean (I::*add) (TPMGL(T)), x10_boolean (I::*addAll) (x10aux::ref<x10::util::Container<TPMGL(T)> >), x10_boolean (I::*addAllWhere) (x10aux::ref<x10::util::Container<TPMGL(T)> >, x10aux::ref<x10::lang::Fun_0_1<TPMGL(T), x10_boolean> >), void (I::*clear) (), x10aux::ref<x10::util::Container<TPMGL(T)> > (I::*clone) (), x10_boolean (I::*contains) (TPMGL(T)), x10_boolean (I::*containsAll) (x10aux::ref<x10::util::Container<TPMGL(T)> >), x10_boolean (I::*equals) (x10aux::ref<x10::lang::Any>), x10_int (I::*hashCode) (), x10_boolean (I::*isEmpty) (), x10aux::ref<x10::lang::Iterator<TPMGL(T)> > (I::*iterator) (), x10_boolean (I::*remove) (TPMGL(T)), x10_boolean (I::*removeAll) (x10aux::ref<x10::util::Container<TPMGL(T)> >), x10_boolean (I::*removeAllWhere) (x10aux::ref<x10::lang::Fun_0_1<TPMGL(T), x10_boolean> >), x10_boolean (I::*retainAll) (x10aux::ref<x10::util::Container<TPMGL(T)> >), x10_int (I::*size) (), x10aux::ref<x10::lang::String> (I::*toString) (), x10aux::ref<x10::lang::String> (I::*typeName) ()) : add(add), addAll(addAll), addAllWhere(addAllWhere), clear(clear), clone(clone), contains(contains), containsAll(containsAll), equals(equals), hashCode(hashCode), isEmpty(isEmpty), iterator(iterator), remove(remove), removeAll(removeAll), removeAllWhere(removeAllWhere), retainAll(retainAll), size(size), toString(toString), typeName(typeName) {}
        x10_boolean (I::*add) (TPMGL(T));
        x10_boolean (I::*addAll) (x10aux::ref<x10::util::Container<TPMGL(T)> >);
        x10_boolean (I::*addAllWhere) (x10aux::ref<x10::util::Container<TPMGL(T)> >, x10aux::ref<x10::lang::Fun_0_1<TPMGL(T), x10_boolean> >);
        void (I::*clear) ();
        x10aux::ref<x10::util::Container<TPMGL(T)> > (I::*clone) ();
        x10_boolean (I::*contains) (TPMGL(T));
        x10_boolean (I::*containsAll) (x10aux::ref<x10::util::Container<TPMGL(T)> >);
        x10_boolean (I::*equals) (x10aux::ref<x10::lang::Any>);
        x10_int (I::*hashCode) ();
        x10_boolean (I::*isEmpty) ();
        x10aux::ref<x10::lang::Iterator<TPMGL(T)> > (I::*iterator) ();
        x10_boolean (I::*remove) (TPMGL(T));
        x10_boolean (I::*removeAll) (x10aux::ref<x10::util::Container<TPMGL(T)> >);
        x10_boolean (I::*removeAllWhere) (x10aux::ref<x10::lang::Fun_0_1<TPMGL(T), x10_boolean> >);
        x10_boolean (I::*retainAll) (x10aux::ref<x10::util::Container<TPMGL(T)> >);
        x10_int (I::*size) ();
        x10aux::ref<x10::lang::String> (I::*toString) ();
        x10aux::ref<x10::lang::String> (I::*typeName) ();
    };
    
    template <class R> static x10_boolean add(x10aux::ref<R> _recv, TPMGL(T) arg0) {
        x10aux::ref<x10::lang::Reference> _refRecv(_recv);
        return (_refRecv.operator->()->*(x10aux::findITable<x10::util::Set<TPMGL(T)> >(_refRecv->_getITables())->add))(arg0);
    }
    template <class R> static x10_boolean add(R _recv, TPMGL(T) arg0) {
        return _recv->add(arg0);
    }
    template <class R> static x10_boolean addAll(x10aux::ref<R> _recv, x10aux::ref<x10::util::Container<TPMGL(T)> > arg0) {
        x10aux::ref<x10::lang::Reference> _refRecv(_recv);
        return (_refRecv.operator->()->*(x10aux::findITable<x10::util::Set<TPMGL(T)> >(_refRecv->_getITables())->addAll))(arg0);
    }
    template <class R> static x10_boolean addAll(R _recv, x10aux::ref<x10::util::Container<TPMGL(T)> > arg0) {
        return _recv->addAll(arg0);
    }
    template <class R> static x10_boolean addAllWhere(x10aux::ref<R> _recv, x10aux::ref<x10::util::Container<TPMGL(T)> > arg0, x10aux::ref<x10::lang::Fun_0_1<TPMGL(T), x10_boolean> > arg1) {
        x10aux::ref<x10::lang::Reference> _refRecv(_recv);
        return (_refRecv.operator->()->*(x10aux::findITable<x10::util::Set<TPMGL(T)> >(_refRecv->_getITables())->addAllWhere))(arg0, arg1);
    }
    template <class R> static x10_boolean addAllWhere(R _recv, x10aux::ref<x10::util::Container<TPMGL(T)> > arg0, x10aux::ref<x10::lang::Fun_0_1<TPMGL(T), x10_boolean> > arg1) {
        return _recv->addAllWhere(arg0, arg1);
    }
    template <class R> static void clear(x10aux::ref<R> _recv) {
        x10aux::ref<x10::lang::Reference> _refRecv(_recv);
        (_refRecv.operator->()->*(x10aux::findITable<x10::util::Set<TPMGL(T)> >(_refRecv->_getITables())->clear))();
    }
    template <class R> static void clear(R _recv) {
        _recv->clear();
    }
    template <class R> static x10aux::ref<x10::util::Collection<TPMGL(T)> > clone(x10aux::ref<R> _recv) {
        x10aux::ref<x10::lang::Reference> _refRecv(_recv);
        return (_refRecv.operator->()->*(x10aux::findITable<x10::util::Set<TPMGL(T)> >(_refRecv->_getITables())->clone))();
    }
    template <class R> static x10aux::ref<x10::util::Collection<TPMGL(T)> > clone(R _recv) {
        return _recv->clone();
    }
    template <class R> static x10_boolean contains(x10aux::ref<R> _recv, TPMGL(T) arg0) {
        x10aux::ref<x10::lang::Reference> _refRecv(_recv);
        return (_refRecv.operator->()->*(x10aux::findITable<x10::util::Set<TPMGL(T)> >(_refRecv->_getITables())->contains))(arg0);
    }
    template <class R> static x10_boolean contains(R _recv, TPMGL(T) arg0) {
        return _recv->contains(arg0);
    }
    template <class R> static x10_boolean containsAll(x10aux::ref<R> _recv, x10aux::ref<x10::util::Container<TPMGL(T)> > arg0) {
        x10aux::ref<x10::lang::Reference> _refRecv(_recv);
        return (_refRecv.operator->()->*(x10aux::findITable<x10::util::Set<TPMGL(T)> >(_refRecv->_getITables())->containsAll))(arg0);
    }
    template <class R> static x10_boolean containsAll(R _recv, x10aux::ref<x10::util::Container<TPMGL(T)> > arg0) {
        return _recv->containsAll(arg0);
    }
    template <class R> static x10_boolean equals(x10aux::ref<R> _recv, x10aux::ref<x10::lang::Any> arg0) {
        x10aux::ref<x10::lang::Reference> _refRecv(_recv);
        return (_refRecv.operator->()->*(x10aux::findITable<x10::util::Set<TPMGL(T)> >(_refRecv->_getITables())->equals))(arg0);
    }
    template <class R> static x10_boolean equals(R _recv, x10aux::ref<x10::lang::Any> arg0) {
        return _recv->equals(arg0);
    }
    template <class R> static x10_int hashCode(x10aux::ref<R> _recv) {
        x10aux::ref<x10::lang::Reference> _refRecv(_recv);
        return (_refRecv.operator->()->*(x10aux::findITable<x10::util::Set<TPMGL(T)> >(_refRecv->_getITables())->hashCode))();
    }
    template <class R> static x10_int hashCode(R _recv) {
        return _recv->hashCode();
    }
    template <class R> static x10_boolean isEmpty(x10aux::ref<R> _recv) {
        x10aux::ref<x10::lang::Reference> _refRecv(_recv);
        return (_refRecv.operator->()->*(x10aux::findITable<x10::util::Set<TPMGL(T)> >(_refRecv->_getITables())->isEmpty))();
    }
    template <class R> static x10_boolean isEmpty(R _recv) {
        return _recv->isEmpty();
    }
    template <class R> static x10aux::ref<x10::lang::Iterator<TPMGL(T)> > iterator(x10aux::ref<R> _recv) {
        x10aux::ref<x10::lang::Reference> _refRecv(_recv);
        return (_refRecv.operator->()->*(x10aux::findITable<x10::util::Set<TPMGL(T)> >(_refRecv->_getITables())->iterator))();
    }
    template <class R> static x10aux::ref<x10::lang::Iterator<TPMGL(T)> > iterator(R _recv) {
        return _recv->iterator();
    }
    template <class R> static x10_boolean remove(x10aux::ref<R> _recv, TPMGL(T) arg0) {
        x10aux::ref<x10::lang::Reference> _refRecv(_recv);
        return (_refRecv.operator->()->*(x10aux::findITable<x10::util::Set<TPMGL(T)> >(_refRecv->_getITables())->remove))(arg0);
    }
    template <class R> static x10_boolean remove(R _recv, TPMGL(T) arg0) {
        return _recv->remove(arg0);
    }
    template <class R> static x10_boolean removeAll(x10aux::ref<R> _recv, x10aux::ref<x10::util::Container<TPMGL(T)> > arg0) {
        x10aux::ref<x10::lang::Reference> _refRecv(_recv);
        return (_refRecv.operator->()->*(x10aux::findITable<x10::util::Set<TPMGL(T)> >(_refRecv->_getITables())->removeAll))(arg0);
    }
    template <class R> static x10_boolean removeAll(R _recv, x10aux::ref<x10::util::Container<TPMGL(T)> > arg0) {
        return _recv->removeAll(arg0);
    }
    template <class R> static x10_boolean removeAllWhere(x10aux::ref<R> _recv, x10aux::ref<x10::lang::Fun_0_1<TPMGL(T), x10_boolean> > arg0) {
        x10aux::ref<x10::lang::Reference> _refRecv(_recv);
        return (_refRecv.operator->()->*(x10aux::findITable<x10::util::Set<TPMGL(T)> >(_refRecv->_getITables())->removeAllWhere))(arg0);
    }
    template <class R> static x10_boolean removeAllWhere(R _recv, x10aux::ref<x10::lang::Fun_0_1<TPMGL(T), x10_boolean> > arg0) {
        return _recv->removeAllWhere(arg0);
    }
    template <class R> static x10_boolean retainAll(x10aux::ref<R> _recv, x10aux::ref<x10::util::Container<TPMGL(T)> > arg0) {
        x10aux::ref<x10::lang::Reference> _refRecv(_recv);
        return (_refRecv.operator->()->*(x10aux::findITable<x10::util::Set<TPMGL(T)> >(_refRecv->_getITables())->retainAll))(arg0);
    }
    template <class R> static x10_boolean retainAll(R _recv, x10aux::ref<x10::util::Container<TPMGL(T)> > arg0) {
        return _recv->retainAll(arg0);
    }
    template <class R> static x10_int size(x10aux::ref<R> _recv) {
        x10aux::ref<x10::lang::Reference> _refRecv(_recv);
        return (_refRecv.operator->()->*(x10aux::findITable<x10::util::Set<TPMGL(T)> >(_refRecv->_getITables())->size))();
    }
    template <class R> static x10_int size(R _recv) {
        return _recv->size();
    }
    template <class R> static x10aux::ref<x10::lang::String> toString(x10aux::ref<R> _recv) {
        x10aux::ref<x10::lang::Reference> _refRecv(_recv);
        return (_refRecv.operator->()->*(x10aux::findITable<x10::util::Set<TPMGL(T)> >(_refRecv->_getITables())->toString))();
    }
    template <class R> static x10aux::ref<x10::lang::String> toString(R _recv) {
        return _recv->toString();
    }
    template <class R> static x10aux::ref<x10::lang::String> typeName(x10aux::ref<R> _recv) {
        x10aux::ref<x10::lang::Reference> _refRecv(_recv);
        return (_refRecv.operator->()->*(x10aux::findITable<x10::util::Set<TPMGL(T)> >(_refRecv->_getITables())->typeName))();
    }
    template <class R> static x10aux::ref<x10::lang::String> typeName(R _recv) {
        return _recv->typeName();
    }
    
};
template <> class Set<void> {
    public:
    static x10aux::RuntimeType rtt;
    static const x10aux::RuntimeType* getRTT() { return & rtt; }
    
};

} } 
#endif // X10_UTIL_SET_H

namespace x10 { namespace util { 
template<class TPMGL(T)> class Set;
} } 

#ifndef X10_UTIL_SET_H_NODEPS
#define X10_UTIL_SET_H_NODEPS
#include <x10/lang/Any.h>
#include <x10/util/Collection.h>
#ifndef X10_UTIL_SET_H_GENERICS
#define X10_UTIL_SET_H_GENERICS
#endif // X10_UTIL_SET_H_GENERICS
#ifndef X10_UTIL_SET_H_IMPLEMENTATION
#define X10_UTIL_SET_H_IMPLEMENTATION
#include <x10/util/Set.h>

template<class TPMGL(T)> x10aux::RuntimeType x10::util::Set<TPMGL(T)>::rtt;
template<class TPMGL(T)> void x10::util::Set<TPMGL(T)>::_initRTT() {
    const x10aux::RuntimeType *canonical = x10aux::getRTT<x10::util::Set<void> >();
    if (rtt.initStageOne(canonical)) return;
    const x10aux::RuntimeType* parents[2] = { x10aux::getRTT<x10::lang::Any>(), x10aux::getRTT<x10::util::Collection<TPMGL(T)> >()};
    const x10aux::RuntimeType* params[1] = { x10aux::getRTT<TPMGL(T)>()};
    x10aux::RuntimeType::Variance variances[1] = { x10aux::RuntimeType::invariant};
    const char *baseName = "x10.util.Set";
    rtt.initStageTwo(baseName, x10aux::RuntimeType::interface_kind, 2, parents, 1, params, variances);
}
#endif // X10_UTIL_SET_H_IMPLEMENTATION
#endif // __X10_UTIL_SET_H_NODEPS
